ghc-7.0.3: The GHC API

TcGenDeriv

# Documentation

type DerivAuxBinds = [DerivAuxBind]

isDupAux :: DerivAuxBind -> DerivAuxBind -> Bool

gen_Bounded_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Enum_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Eq_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Ix_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Ord_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Read_binds :: FixityEnv -> SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Show_binds :: FixityEnv -> SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Data_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Typeable_binds :: SrcSpan -> TyCon -> LHsBinds RdrName

gen_Functor_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

data FFoldType a

Constructors

FT |

Fields

ft_triv :: a
ft_var :: a
ft_co_var :: a
ft_fun :: a -> a -> a
ft_tup :: Boxity -> [a] -> a
ft_ty_app :: Type -> a -> a
ft_bad_app :: a
ft_forall :: TcTyVar -> a -> a

functorLikeTraverse

Arguments

:: TyVar | Variable to look for
-> FFoldType a | How to fold
-> Type | Type to process
-> a |

deepSubtypesContaining :: TyVar -> Type -> [TcType]

foldDataConArgs :: FFoldType a -> DataCon -> [a]

gen_Foldable_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

gen_Traversable_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)

genAuxBind :: SrcSpan -> DerivAuxBind -> (LHsBind RdrName, LSig RdrName)